﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Effects;

namespace PerlinNoiseShader.PerlinNoise2D
{
    public class PrepPerlinNoiseEffect:ShaderEffect
    {
        public PrepPerlinNoiseEffect()
        {
            Uri u = new Uri(@"/PerlinNoiseShader;component/PerlinNoise2D/PrepPerlinNoise.ps", UriKind.Relative);
            PixelShader = new PixelShader() { UriSource = u };
            
            UpdateShaderValue(pArrayProperty);
            UpdateShaderValue(gArrayProperty);
            
        }
        public static readonly DependencyProperty pArrayProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("pArray", typeof(PrepPerlinNoiseEffect), 0);
        public static readonly DependencyProperty gArrayProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("gArray", typeof(PrepPerlinNoiseEffect), 1);
        
        

        public Brush pArray
        {
            get { return (Brush)GetValue(pArrayProperty); }
            set { SetValue(pArrayProperty, value); }
        }

        public Brush gArray
        {
            get { return (Brush)GetValue(gArrayProperty); }
            set { SetValue(gArrayProperty, value); }
        }

                
    }
}
