﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace PerlinNoiseShader
{
    public class Vector3d
    {
        public double x,y,z;
        public Vector3d()
        {
            x = y = z = 0;
        }
        public Vector3d(double x, double y, double z)
        {
            this.x = x;
            this.y = y;
            this.z = z;
        }

        public Vector3d cross(Vector3d oVector3d)
        {
            Vector3d result = new Vector3d();
            result.x = (y * oVector3d.z) - (z * oVector3d.y);
            result.y = (z * oVector3d.x) - (x * oVector3d.z);
            result.z = (x * oVector3d.y) - (y * oVector3d.x);
            return result;
        }
        public Vector3d normalize()
        {
            double length = Math.Sqrt(x * x + y * y + z * z);
            return new Vector3d(x/length,y/length,z/length);
        }
    }
}
