﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace PerlinNoiseShader
{
    /// <summary>
    /// base class for all noise classes
    /// </summary>
    public class NoiseMask
    {
        internal Random oRandom;
        internal Size thisSize=new Size();
        internal int thisSeed=-1;
        internal UIElement iUIElement = null, iCustomUIElement = null;
        internal Rectangle oDrawRectangle;
        internal ImageBrush oPBrush;
        internal int[] p = new int[256];
        public Transform oCustomTransform = null;

        public ImageBrush pImageBrush
        {
            get { return oPBrush; }
        }
        
        public int seed
        {
            get { return thisSeed; }
        }

        internal void createRectangle()
        {
            oDrawRectangle.Width = thisSize.Width;
            oDrawRectangle.Height = thisSize.Height;
            oDrawRectangle.Fill = new SolidColorBrush(Color.FromArgb(255, 255, 255, 255));
        }

        public UIElement currentUIElement
        {
            get { return iUIElement; }
        }

        /// <summary>
        /// create perlin noise with a custom silverlight shape
        /// </summary>
        public UIElement customUIElement
        {
            get { return iCustomUIElement; }
            set
            {
                iUIElement = value;
                iCustomUIElement = value;
                if (iUIElement != null)
                {
                    oDrawRectangle = null;
                }
                else
                {
                    oDrawRectangle = new Rectangle();
                    thisSize = new Size();
                    iUIElement = oDrawRectangle;
                }
            }
        }

        internal ImageBrush getP()
        {
            int i, j, k;
            for (i = 0; i < 256; i++) p[i] = i;
            while (--i > 0)
            {
                k = p[i];
                j = (int)(oRandom.Next() % 256);
                p[i] = p[j];
                p[j] = k;
            }
            WriteableBitmap pBitmap = new WriteableBitmap(256, 1);
            for (i = 0; i < 256; i++)
            {
                int value = p[i];
                int value2 = p[(i + 1) & 255];
                pBitmap.Pixels[i] = (value << 16) | (value2 << 8);

            }
            pBitmap.Invalidate();
            ImageBrush oImageBrush = new ImageBrush();
            oImageBrush.ImageSource = pBitmap;
            return oImageBrush;
        }
        
        

    }
}
