﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Effects;
using System.Windows.Media.Imaging;

namespace VoxelSpacing.Shader
{
    public class IllumShader:ShaderEffect
    {
        public static readonly DependencyProperty geoBitmap = ShaderEffect.RegisterPixelShaderSamplerProperty("geoMap", typeof(IllumShader), 0);
        private WriteableBitmap geomap;
        public IllumShader()
        {
            Uri u = new Uri(@"/VoxelSpacing;component/Shader/illumination.ps", UriKind.Relative);
            PixelShader = new PixelShader() { UriSource = u };
            UpdateShaderValue(geoBitmap);
        }

        public WriteableBitmap geoMap
        {
            get { return geomap; }
            set
            {
                ImageBrush oImageBrush = new ImageBrush();
                geomap = value;
                oImageBrush.ImageSource = geomap;
                SetValue(geoBitmap, oImageBrush);
            }
        }


    }
}
